#ifndef NON_NULL_PTR_H
#define NON_NULL_PTR_H

class invalid {};
template <class T>
   class non_null_ptr {
      T *p;
   public:
      non_null_ptr(T *p) : p{ p } {
         if (!p) throw invalid{};
      }
      constexpr operator bool() const noexcept {
         return true;
      }
      T& operator*() noexcept { return *p; }
      const T& operator*() const noexcept { return *p; }
      T* operator->() noexcept {
         return p;
      }
      const T* operator->() const noexcept {
         return p;
      }
      bool operator==(const non_null_ptr &other) const {
         return p == other.p;
      }
      bool operator!=(const non_null_ptr &other) const {
         return !(*this == other);
      }
      // etc.
   };
   
#endif
