#include <iostream>
#include <string>
#include <iomanip>

template <class T>
   class dup_ptr {
      T *p{};
   public:
      dup_ptr() = default;
      dup_ptr(T *p) noexcept : p{ p } { }
      ~dup_ptr() { delete p; }
      constexpr bool empty() const noexcept { return !p; }
      constexpr operator bool() const noexcept { return !empty(); }
      T& operator*() noexcept { return *p; }
      const T& operator*() const noexcept { return *p; }
      T* operator->() noexcept { return p; }
      const T* operator->() const noexcept { return p; }
   };

int main() {
   using namespace std;
   dup_ptr p{ new string{ "Hi there!" } };
   cout << quoted(*p) << " is of size " << p->size() << endl;
} // *p destroyed here

